<template>
  <div>
    <MOSTY.PageTree :searchType="'03'" :isShowLeftTree="false">
      <template #titleright>
        <div class="toggle" :class="{ active: isOpen }" @click="isOpen = !isOpen">
          <span>统计</span>
          <el-icon>
            <DArrowLeft />
          </el-icon>
        </div>
      </template>
      <template #serach>
        <section v-show='isOpen' ref="getHeight">
          <section class="box-sjtj">
            <MOSTY.Assort :title="'预算审核/批复'" style="padding: 0;" />
            <section class="flex">
              <section class="left-tj">
                <Sjtj :info="countlist" :isShowTip="false" :isShowBottom="false" :width="400" mb="6px" />
              </section>
            </section>
          </section>
        </section>
        <el-divider />
        <MOSTY.Search :searchArr="searchArr" @submit="onSearch" :noDisabledDate='true'>
        </MOSTY.Search>
        <el-divider />
        <div class="btnBox">

          <el-button v-if="isShowAuditBtn" type="primary" @click="AuditClick">
            <el-icon>
              <CirclePlus />
            </el-icon>
            <span>汇总提交审核</span>
          </el-button>

          <el-button type="primary" v-loading="loadingShow" @click="onloadExcel">
            <el-icon>
              <Download />
            </el-icon>
            <span>导出</span>
          </el-button>
        </div>
      </template>
      <template #table>
        <section :style="{ 'height': totalHeight }">
          <MOSTY.Table :table-columns="tableColumns" :tableData="tableData" :tableloading="tableloading"
            :isSelect="false" :isSort="false" :tableHeight="'100%'" actionsW="370">
            <template #ctype="{ row }">
              <dict-tag v-if="row.ctype" :options="D_BZ_YSFYLB" :value="row.ctype" :tag="false" />
              <span v-else>无</span>
            </template>
            <template #cwkm="{ row }">
              <dict-tag v-if="row.cwkm" :options="D_TB_YSCWKU" :value="row.cwkm" :tag="false" />
              <span v-else>无</span>
            </template>
            <template #costFee="{ row }">
              {{ row.costFee || 0 }}
            </template>
            <template #state="{ row }">
              <dict-tag v-if="row.state" :options="stateOpt" :value="row.state" :tag="true" />
              <span v-else>无</span>
            </template>
            <template #actions="{ row }">
              <span v-if="!isxgs" class="operesee" @click="seeStatistics(row)"><el-icon>
                  <Compass />
                </el-icon>统计查看</span>
              <span class="operesee" @click="seeDetail(row)"><el-icon>
                  <Compass />
                </el-icon>查看明细</span>
              <span v-if="row.state != 0" class="operedit" @click="auditTimeLine(row)"><el-icon>
                  <Edit />
                </el-icon>审核进度</span>

              <span
                v-if="isAqbmFzr && ((row.state == 1 && isxgs) || (row.state == 3 && isgs) || (row.state == 5 && isSgs))"
                class="operedown" @click="toAudit(row, false)"><el-icon>
                  <EditPen />
                </el-icon>点击审核
              </span>
              <span v-if="isAqbmFzr && ((isgs && row.state > 3) || (isSgs && row.state > 5))" class="operdel"
                @click="toAudit(row, true)"><el-icon>
                  <EditPen />
                </el-icon>驳回
              </span>
            </template>
          </MOSTY.Table>
        </section>
        <!-- <div class="fenye">
          <MOSTY.Pages :pageConfiger="pageConfiger" @changeNo="handleCurrentChange" @changeSize="handleSizeChange" />
        </div> -->
      </template>
      <!-- <template #footer> -->
      <div slot="footer">
        <el-button type="primary">返回</el-button>
      </div>
      <!-- </template> -->
    </MOSTY.PageTree>

    <!-- 县或本部 【点击审核】界面 -->
    <el-dialog :title="dialogTitle" v-model="isShowAuditDialog" width="90vw" :before-close="auditDialogClose">
      <AuditTable v-if="isShowAuditDialog" :years="listQuery.years" :isReject="isReject" :type="dialogType"
        :row="currRow" :title="dialogTitle" @close="auditDialogClose" />
    </el-dialog>
    <!-- 审核进度 -->
    <AuditTimeLine v-if="isShowTimeLine" :years="listQuery.years" :row="currRow" @close="isShowTimeLine = false" />

    <el-dialog :title="xgsTCTitle" v-model="isShowXgsTC" width="90vw" :before-close="xgsTcClose">
      <xgsTC v-if="isShowXgsTC" :years="listQuery.years" :row="currRow" />
    </el-dialog>

    <el-dialog :title="sgsTCTitle" v-model="isShowSgsTC" width="90vw" :before-close="sgsTcClose">
      <sgsTC v-if="isShowSgsTC" :years="listQuery.years" :row="currRow" />
    </el-dialog>
    <!-- 【统计】或者 【省、市审核,驳回】弹框 -->
    <el-dialog :title="statisticsTCTitle" v-model="isShowStatistics" width="90vw" :before-close="statisticsTcClose">
      <statisticsTc v-if="isShowStatistics" :isReject="isReject" :type="dialogType" :years="listQuery.years"
        :row="currRow" @close="statisticsTcClose" />
    </el-dialog>

  </div>
</template>

<script setup>
// 引入
import { reactive, onMounted, ref, getCurrentInstance, nextTick, watch, computed } from 'vue'
import { ElMessage } from "element-plus";
import * as MOSTY from "@/components/MyComponents/index";
import { getApi, deleteApi, putApi, postApi } from "@/api/tobAcco_api.js";
import { exportXlsx, downloadImg } from "@/excel/Export2Excel.js";
import { getItem } from "@/utils/storage";
import { filterYear, filterqx } from "@/utils/auth.js";
import { numAdd } from "@/utils/tools.js";
import AuditTable from './AuditTable.vue';
import AuditTimeLine from './AuditTimeLine.vue';
import statisticsTc from './statisticsTc.vue';
// import SubmitAllAudit from './SubmitAllAudit.vue';
import xgsTC from './com/xgsTC.vue';
import sgsTC from './com/sgsTC.vue';
import Sjtj from '@/views/dataReportWork/aqjypx/components/sjtj.vue'
import {
  getDept
} from "@/api/user-manage";
const { proxy } = getCurrentInstance();
const { D_BZ_YSFYLB, D_TB_YSCWKU } = proxy.$dict("D_BZ_YSFYLB", "D_TB_YSCWKU");
const sybmlist = ref([])
const addplanShow = ref(false);
const addysShow = ref(false);
const isShowXgsTC = ref(false)
/**展示市公司 */
const isShowSgsTC = ref(false)
const statisticsTCTitle = ref('')
const isShowStatistics = ref(false)
const xgsTCTitle = ref('查看详情')
/**市公司标题 */
const sgsTCTitle = ref('查看详情')
/** 当前层级 1省 2市 3县 */
const currLev = ref(3) // 1 省 2 市 3 县
/** 是否显示 审核弹框 */
const isShowAuditDialog = ref(false)
const isShowTimeLine = ref(false)
// const isShowSubmitAllAudit = ref(false)
/** 当前时间是否是上半年 */
const isHalfYear = ref(new Date().getMonth() < 6);
/** 是否是县公司 */
const isxgs = ref(filterqx('isxgs') == '1')
/**市公司 */
const isgs = ref(filterqx('isgs') == '1')
/**省公司 */
const isSgs = ref(filterqx('isSgs') == '1')
/** 当前查看或审核行 */
const currRow = ref({})
const isReject = ref(false)
const dialogType = ref('') // see 查看  edit 编辑
const dialogTitle = ref('')
const searchArr = reactive([
  {
    showType: "year",
    prop: "years",
    width: '250px',
    defaultVal: new Date().getFullYear().toString(),

  },
]);

const isAqbmFzr = ref(false)

const isShowAuditBtn = computed(() => {
  let arr = tableData.value
  if (!arr.length) return false
  /**都是0，或6不需要汇总按钮 */
  let isNoNeed = arr.every((item) => {
    const state = item.state
    return state === '6' || state === '0'
  })
  if (isNoNeed) return false
  let auth = arr.every((item) => {
    /** @type { String } 上报状态 0:未上报 1:部门已上报 2:县审批 3:市汇总 4:市审核 5:省审核 6:通过 */
    const state = item.state
    return state === '0' || (isxgs.value && ['2', '6'].includes(state)) || (isgs.value && ['4', '6'].includes(state)) //都是已上报
  })
  return auth
});


const stateOpt = [
  { label: '未上报', value: '0', elTagType: 'ysshpf-oper-red' },
  { label: '部门已上报', value: '1' },
  { label: '县安全部门负责人审批', value: '2' },
  { label: '市安全部门负责人汇总', value: '3' },
  { label: '市安全部门负责人审核', value: '4' },
  { label: '省安全部门负责人审核', value: '5' },
  { label: '审批通过', value: '6' },
];
const countlist = reactive([
  { title: '总预算', num: 0.0000 + '万元', dm: 'budgetmoney', icon: 'ccss/icon_02.png' },
  { title: '总使用', num: 0.0000 + '万元', dm: 'totalcost', icon: 'ccss/icon_03.png' },
  { title: '总剩余', num: 0.0000 + '万元', dm: 'symoney', icon: 'ccss/icon_04.png' }
])
const loadingShow = ref(false);
const tableloading = ref(false)
const USERID = getItem("USERID")
const ssdept = getItem("deptId")
const title = ref('');//弹窗标题
const type = ref('01');//控制弹窗参数(01:年初预算调整审核新增)
const rowid = ref(null)
const listQuery = reactive({
  pageCurrent: 1,
  pageSize: 20,
  years: new Date().getFullYear().toString(),
  orgid: null,
  ctype: null
});
const isOpen = ref(false);
const tableData = ref([])

const pageConfiger = reactive({
  pageSize: 20,
  pageCurrent: 1,
  total: 0
})
const tableColumns = reactive([
  {
    title: '部门',
    prop: 'orgname',
    width: '200',
    fixed: 'left',
  },
  // {
  //   title: "使用金额(万元)",
  //   prop: "costFee",
  //   width: '200',
  //   slot: true
  // },

  {
    title: "年初预算调整金额(万元)",
    prop: "budgetmoney",
    width: '200',
  },

  {
    title: "年初批复",
    prop: "budget",
    width: '200',
  },
  {
    title: "中期调整增减数",
    prop: "tzzj",
    width: '200',
  },
  {
    title: "中期归口审核增减数",
    prop: "gkshzj",
    width: '200',
  },

  {
    title: "状态",
    prop: "state",
    // width: '180',
    fixed: 'right',
    slot: true
  },
  {
    title: "操作",
    prop: "actions",
    fixed: 'right',
    slot: true
  }
])

const deptid = ref(null)
const orgids = ref(null)
const totalHeight = ref(null)
const getHeight = ref(null)
watch(() => isOpen.value, (val) => {
  nextTick(() => {
    if (val) {
      totalHeight.value = `calc(100vh - ${379 + getHeight.value.offsetHeight}px)`
      return
    }
    totalHeight.value = `calc(100vh - 379px)`
  })
}, {
  deep: true,
  immediate: true
})
const auditDialogClose = () => {
  isShowAuditDialog.value = false
  getDataList()
}
const xgsTcClose = () => {
  isShowXgsTC.value = false
  getDataList()
}
const sgsTcClose = () => {
  isShowSgsTC.value = false
  getDataList()
}
const statisticsTcClose = () => {
  isShowStatistics.value = false
  getDataList()
}
const setIsAqbmFzr = () => {
  getApi({}, '/mosty-jcgl/securitychild/isAqbmFzr').then((res) => {
    isAqbmFzr.value = !!res
  })
}
onMounted(() => {
  nextTick(() => {
    totalHeight.value = `calc(100vh - ${379 + getHeight.value.offsetHeight}px)`
  })
  if (isSgs.value) currLev.value = 1;
  if (isgs.value) currLev.value = 2;
  if (isxgs.value) currLev.value = 3;
  getDataList()
  setIsAqbmFzr()
  // setAuditBtn()
  // getTotaldata()
})
//获取年初查询年初统计
function getTotaldata() {
  getApi(listQuery, "/mosty-jcgl/budgets/getNcBudgetsSum").then((res) => {
    countlist[0].num = res.budget ? `${Number(res.budget).toFixed(4)}万元` : `${0.0000}万元`;
    countlist[1].num = res.totalcost ? `${Number(res.totalcost).toFixed(4)}万元` : `${0.0000}万元`;
    countlist[2].num = res.budget != 0 ? `${numAdd("reduce", 4, res.budget, res.totalcost)}万元` : `${0.0000}万元`;
  });
}
//刷新
function resetTable(val) {
  listQuery.pageSize = 20
  listQuery.pageCurrent = 1
  listQuery.orgid = orgids.value;
  // listQuery.ctype = ''
  deptid.value = ''
  listQuery.years = new Date().getFullYear().toString()
  getDataList();
  // getTotaldata()
  // setAuditBtn()
}

//查询
function onSearch(obj) {
  listQuery.pageCurrent = 1
  // listQuery.ctype = obj.ctype;
  listQuery.years = obj.years;
  // listQuery.cwkm = obj.cwkm;
  getDataList();
  // getTotaldata()
}
//ALL_查询安全投入列表
function getDataList(params) {
  tableloading.value = true
  getApi(listQuery, '/mosty-jcgl/ys/getList').then((res) => {
    if (res) {
      tableloading.value = false;
      tableData.value = Array.isArray(res) ? res : [];
      tableData.value.forEach(async (item) => {
        item.budget = item.budget ? item.budget : 0;
        item.budgetmoney = item.budgetmoney ? item.budgetmoney : 0;
        item.tzzj = item.tzzj ? item.tzzj : 0;
        item.gkshzj = item.gkshzj ? item.gkshzj : 0;
        // item.state = item.state? item.state : 0;
        //   item.pfjeall = numAdd("add", 4, item.budget, item.gkshzj, item.yeargkshzj)
        //   item.symoney = numAdd("reduce", 4, item.pfjeall, item.costFee);
      })
      // pageConfiger.total = res.total;
    }
  }).catch((err) => {
    tableData.value = []
    tableloading.value = false;
  }).finally(() => {
    tableloading.value = false;
  })
}
//添加预算
function onAddys(types, val) {

  title.value = val;
  type.value = types;
  rowid.value = null;
  if (types == 'ndadd') {
    addplanShow.value = true
  } else {
    addysShow.value = true;
  }

}
//年初预算调整审核
function ysshbtn(val, types) {
  type.value = types;
  rowid.value = val.id;
  if (types == 'ncsh') {
    title.value = "年度审核预算"; // “年初”改为“年度”， 年度去掉
    addysShow.value = true;
  } else if (types == 'nzsh') {
    title.value = "中期审核预算";
    addysShow.value = true;
  } else {
    // title.value = '年度预算调整审核';
    // addplanShow.value = true
  }
}

//修改预算
function xgInfo(val) {
  rowid.value = val.id
  if (val.state == '0') {
    title.value = "年度修改预算"; // “年初”改为“年度”， 年度去掉
    type.value = "ncexit";
    addysShow.value = true;
  } else if (val.state == '1' && val.middlestate == '1') {
    title.value = '中期预算调整调整修改';
    type.value = 'nzexit';
    addysShow.value = true;
  } else if (val.middlestate == '2' && val.yearstate != '2') {

    title.value = '年度预算调整调整修改';
    type.value = 'ndexit';
    addplanShow.value = true
  }
}

//查看预算
function seeInfo(val) {
  rowid.value = val.id
  if (val.state == '0') {
    title.value = "年度预算调整详情"; // “年初”改为“年度”， 年度去掉
    type.value = "ncdetails";
    addysShow.value = true;
  } else if (val.state == '1' && val.middlestate == '1') {
    title.value = '中期预算调整详情';
    type.value = 'nzdetails';
    addysShow.value = true;
  } else if (val.middlestate == '2') {
    title.value = '年度填报详情';
    type.value = 'nddetails';
    addplanShow.value = true
  }

}

//删除
function handledelete(val) {
  postApi({}, `/mosty-jcgl/ys/del/${val.id}`).then((res) => {
    ElMessage.success("删除成功");
    resetTable();
  });
}
//分页
const handleSizeChange = (currentSize) => {
  listQuery.pageSize = currentSize;
  pageConfiger.pageSize = currentSize;
  getDataList();
};
const handleCurrentChange = (currentPage) => {
  listQuery.pageCurrent = currentPage;
  pageConfiger.pageCurrent = currentPage;
  getDataList();
};
function AuditClick() {
  proxy.$modal.confirm('确定汇总提交审核？', '提示')
    .then(() => {
      postApi({}, `/mosty-jcgl/ys/hzSubmit?years=${listQuery.years}`).then((res) => {
        ElMessage.success("汇总提交审核成功");
        // resetTable();
        getDataList();
      })
    })
    .catch(() => {
      // catch error
    })
}
function submitAudit() {
  const url = isxgs ? '/ys/hzSubmit' : '/ys/hzAudit'
  postApi({}, url).then((res) => {
    ElMessage.success("提交审核成功");
    getDataList()
  });
}
//导出Excel
function onloadExcel() {
  let title = {
    orgname: '部门',
    // budgettitle: '预算项目',
    // ctype: '费用类型',
    // cwkm: '费用科目',
    budgetmoney: '年初预算调整金额',
    budget: '年初批复',
    tzzj: '中期调整增减数',
    gkshzj: '中期归口审核增减数',
    state: '状态',
  }
  let obj = { ...listQuery };
  // obj.pageSize = 10000
  loadingShow.value = true
  getApi(obj, '/mosty-jcgl/ys/getList').then(async (res) => {
    if (res) {
      let data = res
      if (data) {
        for (let i = 0; i < data.length; i++) {
          data[i].deptname = data[i].deptname || ''
          data[i].ctype = proxy.$getDictVal(data[i].ctype, D_BZ_YSFYLB);
          data[i].cwkm = proxy.$getDictVal(data[i].cwkm, D_TB_YSCWKU);
          data[i].budget = data[i].budget ? data[i].budget : 0
          data[i].budgetmoney = data[i].budgetmoney ? data[i].budgetmoney : 0
          data[i].tzzj = data[i].tzzj ? data[i].tzzj : 0
          data[i].gkshzj = data[i].gkshzj ? data[i].gkshzj : 0
          data[i].state = stateOpt.find(item => item.value == data[i].state)?.label || ''
          data[i].yeartzzj = data[i].yeartzzj ? data[i].yeartzzj : 0
          data[i].yeargkshzj = data[i].yeargkshzj ? data[i].yeargkshzj : 0
          data[i].pfjeall = numAdd("add", 4, data[i].budget, data[i].totalcost, data[i].yeargkshzj)
          // data[i].symoney = numAdd("reduce", 4, data[i].pfjeall, data[i].costFee);
        }
        let tablename = "预算填报列表.xlsx"
        exportXlsx(title, data, '预算填报列表', tablename);
        loadingShow.value = false
      }
    }

  }).catch(err => {
    loadingShow.value = false
  })
}
const seeStatistics = (row) => {
  currRow.value = row
  dialogType.value = 'see'
  statisticsTCTitle.value = `${row.orgname}-统计`
  isShowStatistics.value = true
}
const seeDetail = (row) => {
  console.log('row: ', row);
  currRow.value = row
  console.log('currLev.value: ', currLev.value);
  // 县公司 ， 点击会查下级，即“部门”
  if (currLev.value == 3) {
    dialogType.value = 'see'
    isShowAuditDialog.value = true
    dialogTitle.value = `${row.orgname}-查看详情`
    // 市公司 点击会查下级，即“县公司弹框”
  } else if (currLev.value == 2) {
    xgsTCTitle.value = `${row.orgname}查看详情`
    isShowXgsTC.value = true
    // 省公司
  } else if (currLev.value == 1) {
    sgsTCTitle.value = `${row.orgname}-查看详情`
    isShowSgsTC.value = true
  }
}
const auditTimeLine = (row) => {
  currRow.value = row
  isShowTimeLine.value = true
}
const toReJect = (row) => {
  currRow.value = row
  dialogType.value = 'reject'
  const isHasXN = row.orgid.indexOf('XN') > -1
  if (isHasXN) {
    dialogTitle.value = `${row.orgname}-审核`
    isShowAuditDialog.value = true
    // 省公司账号
  } else if (currLev.value == 1) {
    currRow.value = row
    statisticsTCTitle.value = `${row.orgname}-统计`
    isShowStatistics.value = true
    // 市公司账号
  } else if (currLev.value == 2) {
    currRow.value = row
    statisticsTCTitle.value = `${row.orgname}-统计`
    isShowStatistics.value = true
    // 县公司
  } else if (currLev.value == 3) {
    isShowAuditDialog.value = true
    dialogTitle.value = `${row.orgname}-审核`
  }
}
const toAudit = (row, rejectVal) => {
  currRow.value = row
  dialogType.value = 'audit'
  isReject.value = !!rejectVal
  const isHasXN = row.orgid.indexOf('XN') > -1
  if (isHasXN) {
    dialogTitle.value = `${row.orgname}-审核`
    isShowAuditDialog.value = true
    // 省公司账号
  } else if (currLev.value == 1) {
    currRow.value = row
    statisticsTCTitle.value = `${row.orgname}-列表`
    isShowStatistics.value = true
    // 市公司账号
  } else if (currLev.value == 2) {
    currRow.value = row
    statisticsTCTitle.value = `${row.orgname}-列表`
    isShowStatistics.value = true
    // 县公司
  } else if (currLev.value == 3) {
    isShowAuditDialog.value = true
    dialogTitle.value = `${row.orgname}-审核`
  }
}

</script>

<style lang="scss" scoped>
.btnBox {
  display: flex;
  align-items: center;
  justify-content: flex-end;
  margin-bottom: 12px;
}

.toggle {
  height: 40px;
  cursor: pointer;
  display: flex;
  align-items: center;
  color: #0f3916;

  .el-icon {
    transform: rotate(90deg);
    transition: all 0.25s ease;
  }

  &.active {
    .el-icon {
      transform: rotate(-90deg);
    }
  }
}

::v-deep .ysshpf-oper-red {
  color: red !important;
  border-color: #f7cfcf !important;
}
</style>
